/**********************************************************
Game 3D Test  1.0b for E2 
Written  by Strelok Vlad Kolerts
Powered by T3D
Idea by Dark Bard
10/02/2009
Email: admin@mobsk.org.ua
ICQ: 497123239
Thanks to Lasly and kidscracker
***********************************************************/
#define QT_NO_DRAGANDDROP
#define QT_NO_PROPERTIES
#include <ZApplication.h>
#include <ZKbMainWidget.h>
#include <qtimer.h>

	QString path="/mmc/mmca1/tmp/img/";

class mainWidget : public ZKbMainWidget
{
	Q_OBJECT
	QPixmap 	galem_spr[6];
	QPixmap 	bg;
	QPixmap* 	bg_buf;	
	
	int x, y;
	int move_x, move_y;
	
	int l_hand[2],r_hand[2], count_move;
	
	bool left, right, up, down;
	bool fire, left_h;
	
	int fps, pfps;
	
	
public:
mainWidget():ZKbMainWidget((ZHeader::HEADER_TYPE)3,NULL , "ZMainWidget" , 0)
	{		
		for (int i=0; i<6; i++)
		{
			galem_spr[i]=QPixmap(path+QString("%1.png").arg(i));			
		}
		bg = QPixmap(path+"bg.png");
		
		bg_buf = new QPixmap(240,320);
		
		setFullScreenMode(true, true);		
		setBackgroundColor( Qt::black );	
		resize( 240, 320 );
		x=80;
		y=120;
		left=false;
		right=false;
		up=false;
		down=false;	
		QTimer *timer = new QTimer(this);
		QTimer *timer_fps = new QTimer(this);		
		connect( timer, SIGNAL(timeout()), SLOT(animate()) );
		connect( timer_fps, SIGNAL(timeout()), SLOT(fps_()) );
		timer->start( 50 );
		timer_fps->start( 1000 );
		pfps=20;
	}	

~mainWidget()
	{			
	}
	
void paint()
	{			
		QPainter p;		
		p.begin( bg_buf ,this);
// ---------------------------- рисуем задний план		
		p.drawPixmap(0 ,0 ,bg);
// ---------------------------- рисуем галема
		// левая рука
		p.drawPixmap(x+40-move_x+l_hand[0], y+30-move_y, galem_spr[1]);
		p.drawPixmap(x+10-move_x+l_hand[1], y+25-move_y, galem_spr[0] );				
		p.drawPixmap(x-5-move_x, y-move_y, galem_spr[1]);
		// голова
		p.drawPixmap(x, y,galem_spr[3]);		
		p.drawPixmap(x-10+move_x/2, y+5+move_y/2, galem_spr[2]);
		// правая рука
		p.drawPixmap(x-30+move_x, y+10+move_y, galem_spr[4]);
		p.drawPixmap(x-20+move_x+r_hand[1], y+40+move_y, galem_spr[5]);
		p.drawPixmap(x+10+move_x+r_hand[0], y+45+move_y, galem_spr[4]);
		
		p.setPen(Qt::red);
		p.drawText(5, 25,QString ("fps: %1").arg(pfps), 50);
		p.end();		
		
		bitBlt( this,0, 0, bg_buf );
		fps++;
	}
	
void move_up()
	{		
		y=y-5;
		move_y=move_y-1;		
	}

void move_down()
	{
		y=y+5;
		move_y=move_y+1;		
	}			

void move_left()
	{
		x=x-5;
		move_x=move_x-1;		
	}

void move_right()
	{
		x=x+5;
		move_x=move_x+1;		
	}

void mainWidget::keyPressEvent(QKeyEvent* k)	//keyReleaseEvent
	{		
		switch(k->key())
		{	
			case 4115://(Up) 				
				up=true;				
			break;
			
			case 50:				
				up=true;				
			break;
			
			case 4117:// (Down)
				down=true;
			break;
			
			case 56:
				down=true;
			break;			
			
			case 4114:// (Left)
				left=true;
			break;
			
			case 52:
				left=true;
			break;
			
			case 4116://(Right)	
				right=true;
			break;
			
			case 54:
				right=true;
			break;
			
			case 4100://(fire)
				fire=true;
			break;
			
			case 53://(fire)				
				exit(1);
			break;
			
			default:			
			break;
		}			
	}
	
void mainWidget::keyReleaseEvent(QKeyEvent* k)	//keyReleaseEvent
	{		
		switch(k->key())
		{	
			case 4115://(Up) 
				up=false;
			break;
			
			case 50://(Up) 
				up=false;
			break;
			
			case 4117:// (Down)
				down=false;
			break;	
			
			case 56:// (Down)
				down=false;
			break;			
			
			case 4114:// (Left)
				left=false;
			break;
			
			case 52:// (Left)
				left=false;
			break;
			
			case 4116:// вниз страница(Right)
				right=false;
			break;
			
			case 54:// вниз страница(Right)
				right=false;
			break;
			
			case 4100://(fire)
				fire=false;
			break;
			
			case 53://(fire)
				fire=false;
			break;
			
			default:			
			break;
		}			
	}
	
public slots:

void animate()
	{
		//if (!fire)
		//{	
			if (up) 	move_up();
			if (down) 	move_down();
			if (left) 	move_left();
			if (right) 	move_right();
		//}
		
		if (fire or count_move!=1)
		{	
			if(count_move>=14)
			{
				if (left_h)left_h=false;
				else left_h=true;
				count_move=0;
			}
			if (left_h) 
			{
				l_hand[0]=l_hand[0]-3;l_hand[1]=l_hand[1]-3;
				if (l_hand[1]<=-10)l_hand[1]=-10;if (l_hand[0]<=-15)l_hand[0]=-15;
				r_hand[0]=r_hand[0]+10;r_hand[1]=r_hand[1]+10;
				if (r_hand[1]>=20)r_hand[1]=20;if (r_hand[0]>=25)r_hand[0]=25;
			}
			else 
			{
				r_hand[0]=r_hand[0]-3;r_hand[1]=r_hand[1]-3;
				if (r_hand[1]<=-10)r_hand[1]=-10;if (r_hand[0]<=-15)r_hand[0]=-15;
				l_hand[0]=l_hand[0]+10;l_hand[1]=l_hand[1]+10;
				if (l_hand[1]>=20)l_hand[1]=20;if (l_hand[0]>=25)l_hand[0]=25;}
			count_move=count_move+1;
		}
		else {l_hand[0]=0;r_hand[0]=0;l_hand[1]=0;r_hand[1]=0;	}

		paint();
		
	}	
	
void fps_()
	{
		pfps=fps;
		fps=0;
	}
	
};

int main( int argc, char **argv )
{
	ZApplication* a = new ZApplication( argc, argv );	
	mainWidget* mw = new mainWidget();
   	a->setMainWidget( mw ); 
	   	mw->show();
	int ret = a->exec();
	delete mw;
	delete a;
   	return ret;
}

#include "game.moc"
